var UIP;

function ImportarCatalogoDepartamentos(){	
	var IDepartamento;
	var EFile;
	var ESheet;
	var lgItems;
	var itRows;
	var stFile;
	var stTemp;
	var itCount=0;
	var codigoP="";
	
	stFile=Application.OpenFile("Archivos de excel (*.xls)|*.xls");	
	if (stFile==""){		
		return false;
	}
		
	UIP=Application.NewUIProgress();
	UIP.Caption="Importando departamentos";
	UIP.Min=0;
	
	EFile=Application.NewObject("Excel.Application");
	EFile.WorkBooks.Open (stFile);
	IDepartamento=Application.NewObject("EDOFx.Departamento");
	IDepartamento.ADOCnn=Application.adoCnn;
	
    // si es la versin de Excel 97, asigna la hoja activa ( ActiveSheet )
	if (EFile.Application.Version>=8){
		ESheet = EFile.ActiveSheet;
	}
	else{
		ESheet = EFile;
	}
	
	itRows=ESheet.UsedRange.Rows.Count;
	UIP.Max=itRows;
	UIP.Show();
	
	Application.MouseHourglass();
		
	for (lgItems=2;lgItems<=itRows;lgItems++){
	
		try{
			IDepartamento.AddNew();
					
			if (IDepartamento.LoadFromADOCByCodigo(ESheet.Cells(lgItems,1))==false){
				codigoP="";
				codigoP=ESheet.Cells(lgItems,1);						
				codigoP=codigoP+"";
				codigoP=codigoP.toUpperCase();
				IDepartamento.Codigo=codigoP;
							
				IDepartamento.Descripcion=ESheet.Cells(lgItems,2);
				
				UIP.TopTitle="Almacenando "+IDepartamento.Descripcion;
				
				IDepartamento.Comision1=ESheet.Cells(lgItems,3);
				IDepartamento.Comision2=ESheet.Cells(lgItems,4);
				IDepartamento.Comision3=ESheet.Cells(lgItems,5);
				IDepartamento.Comision4=ESheet.Cells(lgItems,6);
				IDepartamento.Comision5=ESheet.Cells(lgItems,7);
								
				if (!IDepartamento.Update()){
					Log("Error al procesar fila "+lgItems+". Error al guardar departamento ("+IDepartamento.Descripcion+") "+IDepartamento.lastErrDescrip);
				}
				else{
					itCount=itCount+1;
				}
			}else{
				Log("Error al procesar fila "+lgItems+". El departamento con cdigo "+ESheet.Cells(lgItems,1)+" ya se encuentra registrado.");
			}
			
		}catch(e){
			Log("Error al procesar fila "+lgItems);
		}
		UIP.Value=lgItems;
		Application.eDoEvents();
	}
	
	Application.CloseUIProgress(UIP);
	Application.MouseDefault();
	eBasic.eMsgbox("Cantidad de registros importados "+itCount,6);
	EFile.ActiveWorkBook.Close(false);
	EFile.Quit();
	IDepartamento=null;
	EFile=null;
	ESheet=null;
	return true;
}

function Log(Error){
	if (Error!="")
		Application.FireEventLog(Error);
}

function Procesar(){
	try{
		return ImportarCatalogoDepartamentos();
	}catch(e)
	{
		if(UIP!=null){
			Application.CloseUIProgress(UIP);
			Application.MouseDefault();
		}
		Log("Error al ejecutar subprograma");
		throw e;
		return false;
	}
}
Procesar();